searchNodes=[{"ref":"GoogleApi.ServiceControl.V1.Api.Services.html","title":"GoogleApi.ServiceControl.V1.Api.Services","type":"module","doc":"API calls for all endpoints tagged Services."},{"ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_allocate_quota/4","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_allocate_quota/4","type":"function","doc":"Attempts to allocate quota for the specified consumer. It should be called before the operation is executed. This method requires the &#x60;servicemanagement.services.quota&#x60; permission on the specified service. For more information, see Cloud IAM. NOTE: The client must fail-open on server errors &#x60;INTERNAL&#x60;, &#x60;UNKNOWN&#x60;, &#x60;DEADLINE_EXCEEDED&#x60;, and &#x60;UNAVAILABLE&#x60;. To ensure system reliability, the server may inject these errors to prohibit any hard dependency on the quota functionality. Parameters connection (GoogleApi.ServiceControl.V1.Connection): Connection to server service_name (String.t): Name of the service as specified in the service configuration. For example, &#x60;&quot;pubsub.googleapis.com&quot;&#x60;. See google.api.Service for the definition of a service name. optional_params (KeywordList): [optional] Optional parameters :$.xgafv (String.t): V1 error format. :access_token (String.t): OAuth access token. :alt (String.t): Data format for response. :callback (String.t): JSONP :fields (String.t): Selector specifying which fields to include in a partial response. :key (String.t): API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (String.t): OAuth 2.0 token for the current user. :prettyPrint (boolean()): Returns response with indentations and line breaks. :quotaUser (String.t): Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :upload_protocol (String.t): Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :uploadType (String.t): Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :body (AllocateQuotaRequest): Returns {:ok, %GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_check/4","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_check/4","type":"function","doc":"Checks whether an operation on a service should be allowed to proceed based on the configuration of the service and related policies. It must be called before the operation is executed. If feasible, the client should cache the check results and reuse them for 60 seconds. In case of any server errors, the client should rely on the cached results for much longer time to avoid outage. WARNING: There is general 60s delay for the configuration and policy propagation, therefore callers MUST NOT depend on the &#x60;Check&#x60; method having the latest policy information. NOTE: the CheckRequest has the size limit of 64KB. This method requires the &#x60;servicemanagement.services.check&#x60; permission on the specified service. For more information, see Cloud IAM. Parameters connection (GoogleApi.ServiceControl.V1.Connection): Connection to server service_name (String.t): The service name as specified in its service configuration. For example, &#x60;&quot;pubsub.googleapis.com&quot;&#x60;. See google.api.Service for the definition of a service name. optional_params (KeywordList): [optional] Optional parameters :$.xgafv (String.t): V1 error format. :access_token (String.t): OAuth access token. :alt (String.t): Data format for response. :callback (String.t): JSONP :fields (String.t): Selector specifying which fields to include in a partial response. :key (String.t): API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (String.t): OAuth 2.0 token for the current user. :prettyPrint (boolean()): Returns response with indentations and line breaks. :quotaUser (String.t): Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :upload_protocol (String.t): Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :uploadType (String.t): Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :body (CheckRequest): Returns {:ok, %GoogleApi.ServiceControl.V1.Model.CheckResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.ServiceControl.V1.Api.Services.html#servicecontrol_services_report/4","title":"GoogleApi.ServiceControl.V1.Api.Services.servicecontrol_services_report/4","type":"function","doc":"Reports operation results to Google Service Control, such as logs and metrics. It should be called after an operation is completed. If feasible, the client should aggregate reporting data for up to 5 seconds to reduce API traffic. Limiting aggregation to 5 seconds is to reduce data loss during client crashes. Clients should carefully choose the aggregation time window to avoid data loss risk more than 0.01% for business and compliance reasons. NOTE: the ReportRequest has the size limit of 1MB. This method requires the &#x60;servicemanagement.services.report&#x60; permission on the specified service. For more information, see Google Cloud IAM. Parameters connection (GoogleApi.ServiceControl.V1.Connection): Connection to server service_name (String.t): The service name as specified in its service configuration. For example, &#x60;&quot;pubsub.googleapis.com&quot;&#x60;. See google.api.Service for the definition of a service name. optional_params (KeywordList): [optional] Optional parameters :$.xgafv (String.t): V1 error format. :access_token (String.t): OAuth access token. :alt (String.t): Data format for response. :callback (String.t): JSONP :fields (String.t): Selector specifying which fields to include in a partial response. :key (String.t): API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (String.t): OAuth 2.0 token for the current user. :prettyPrint (boolean()): Returns response with indentations and line breaks. :quotaUser (String.t): Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :upload_protocol (String.t): Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :uploadType (String.t): Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :body (ReportRequest): Returns {:ok, %GoogleApi.ServiceControl.V1.Model.ReportResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html","title":"GoogleApi.ServiceControl.V1.Connection","type":"module","doc":"Handle Tesla connections for GoogleApi.ServiceControl.V1."},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#delete/3","title":"GoogleApi.ServiceControl.V1.Connection.delete/3","type":"function","doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete(&quot;/users&quot;) delete(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete(client, &quot;/users&quot;) delete(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#delete!/3","title":"GoogleApi.ServiceControl.V1.Connection.delete!/3","type":"function","doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete!(&quot;/users&quot;) delete!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete!(client, &quot;/users&quot;) delete!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#execute/2","title":"GoogleApi.ServiceControl.V1.Connection.execute/2","type":"function","doc":"Execute a request on this connection Returns Tesla.Env"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#get/3","title":"GoogleApi.ServiceControl.V1.Connection.get/3","type":"function","doc":"Perform a GET request. See request/1 or request/2 for options definition. get(&quot;/users&quot;) get(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get(client, &quot;/users&quot;) get(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#get!/3","title":"GoogleApi.ServiceControl.V1.Connection.get!/3","type":"function","doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get!(&quot;/users&quot;) get!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get!(client, &quot;/users&quot;) get!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#head/3","title":"GoogleApi.ServiceControl.V1.Connection.head/3","type":"function","doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head(&quot;/users&quot;) head(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head(client, &quot;/users&quot;) head(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#head!/3","title":"GoogleApi.ServiceControl.V1.Connection.head!/3","type":"function","doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head!(&quot;/users&quot;) head!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head!(client, &quot;/users&quot;) head!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#new/0","title":"GoogleApi.ServiceControl.V1.Connection.new/0","type":"function","doc":"Configure an authless client connection Returns Tesla.Client.t"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#new/1","title":"GoogleApi.ServiceControl.V1.Connection.new/1","type":"function","doc":"Configure a client connection using a function which yields a Bearer token. Parameters token_fetcher (function arity of 1): Callback which provides an OAuth2 token given a list of scopes Returns Tesla.Env.client"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#options/3","title":"GoogleApi.ServiceControl.V1.Connection.options/3","type":"function","doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options(&quot;/users&quot;) options(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options(client, &quot;/users&quot;) options(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#options!/3","title":"GoogleApi.ServiceControl.V1.Connection.options!/3","type":"function","doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options!(&quot;/users&quot;) options!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options!(client, &quot;/users&quot;) options!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#patch/4","title":"GoogleApi.ServiceControl.V1.Connection.patch/4","type":"function","doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#patch!/4","title":"GoogleApi.ServiceControl.V1.Connection.patch!/4","type":"function","doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#post/4","title":"GoogleApi.ServiceControl.V1.Connection.post/4","type":"function","doc":"Perform a POST request. See request/1 or request/2 for options definition. post(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#post!/4","title":"GoogleApi.ServiceControl.V1.Connection.post!/4","type":"function","doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#put/4","title":"GoogleApi.ServiceControl.V1.Connection.put/4","type":"function","doc":"Perform a PUT request. See request/1 or request/2 for options definition. put(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#put!/4","title":"GoogleApi.ServiceControl.V1.Connection.put!/4","type":"function","doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#request/2","title":"GoogleApi.ServiceControl.V1.Connection.request/2","type":"function","doc":"Perform a request Options: :method - the request method, one of [:head, :get, :delete, :trace, :options, :post, :put, :patch] :url - either full url e.g. &quot;http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples: ExampleApi.request(method: :get, url: &quot;/users/path&quot;) You can also use shortcut methods like: ExampleApi.get(&quot;/users/1&quot;) or ExampleApi.post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;})"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#request!/2","title":"GoogleApi.ServiceControl.V1.Connection.request!/2","type":"function","doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options."},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#trace/3","title":"GoogleApi.ServiceControl.V1.Connection.trace/3","type":"function","doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace(&quot;/users&quot;) trace(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace(client, &quot;/users&quot;) trace(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#trace!/3","title":"GoogleApi.ServiceControl.V1.Connection.trace!/3","type":"function","doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace!(&quot;/users&quot;) trace!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace!(client, &quot;/users&quot;) trace!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.ServiceControl.V1.Connection.html#t:option/0","title":"GoogleApi.ServiceControl.V1.Connection.option/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Deserializer.html","title":"GoogleApi.ServiceControl.V1.Deserializer","type":"module","doc":"Helper functions for deserializing responses into models. This module is no longer used. Please use GoogleApi.Gax.ModelBase instead."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo","type":"module","doc":"Attributes unusedArguments ([String.t]): A list of label keys that were unused by the server in processing the request. Thus, for similar requests repeated in a certain future time window, the caller can choose to ignore these labels in the requests to achieve better client-side cache hits and quota aggregation. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AllocateInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest","type":"module","doc":"Request message for the AllocateQuota method. Attributes allocateOperation (QuotaOperation): Operation that describes the quota allocation. Defaults to: null. serviceConfigId (String.t): Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse","type":"module","doc":"Response message for the AllocateQuota method. Attributes allocateErrors ([QuotaError]): Indicates the decision of the allocate. Defaults to: null. allocateInfo (AllocateInfo): WARNING: DO NOT use this field until this warning message is removed. Defaults to: null. operationId (String.t): The same operation_id value used in the AllocateQuotaRequest. Used for logging and diagnostics purposes. Defaults to: null. quotaMetrics ([MetricValueSet]): Quota metrics to indicate the result of allocation. Depending on the request, one or more of the following metrics will be included: 1. Per quota group or per quota metric incremental usage will be specified using the following delta metric : &quot;serviceruntime.googleapis.com/api/consumer/quota_used_count&quot; 2. The quota limit reached condition will be specified using the following boolean metric : &quot;serviceruntime.googleapis.com/quota/exceeded&quot; Defaults to: null. serviceConfigId (String.t): ID of the actual config used to process the request. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AllocateQuotaResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html","title":"GoogleApi.ServiceControl.V1.Model.AuditLog","type":"module","doc":"Common audit log format for Google Cloud Platform API operations. Attributes authenticationInfo (AuthenticationInfo): Authentication information. Defaults to: null. authorizationInfo ([AuthorizationInfo]): Authorization information. If there are multiple resources or permissions involved, then there is one AuthorizationInfo element for each {resource, permission} tuple. Defaults to: null. metadata (%{optional(String.t) &#x3D;&gt; String.t}): Other service-specific data about the request, response, and other information associated with the current audited event. Defaults to: null. methodName (String.t): The name of the service method or operation. For API calls, this should be the name of the API method. For example, &quot;google.datastore.v1.Datastore.RunQuery&quot; &quot;google.logging.v1.LoggingService.DeleteLog&quot; Defaults to: null. numResponseItems (String.t): The number of items returned from a List or Query API method, if applicable. Defaults to: null. request (%{optional(String.t) &#x3D;&gt; String.t}): The operation request. This may not include all request parameters, such as those that are too large, privacy-sensitive, or duplicated elsewhere in the log record. It should never include user-generated data, such as file contents. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the &#x60;@type&#x60; property. Defaults to: null. requestMetadata (RequestMetadata): Metadata about the operation. Defaults to: null. resourceLocation (ResourceLocation): The resource location information. Defaults to: null. resourceName (String.t): The resource or collection that is the target of the operation. The name is a scheme-less URI, not including the API service name. For example: &quot;shelves/SHELF_ID/books&quot; &quot;shelves/SHELF_ID/books/BOOK_ID&quot; Defaults to: null. resourceOriginalState (%{optional(String.t) &#x3D;&gt; String.t}): The resource&#39;s original state before mutation. Present only for operations which have successfully modified the targeted resource(s). In general, this field should contain all changed fields, except those that are already been included in &#x60;request&#x60;, &#x60;response&#x60;, &#x60;metadata&#x60; or &#x60;service_data&#x60; fields. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the &#x60;@type&#x60; property. Defaults to: null. response (%{optional(String.t) &#x3D;&gt; String.t}): The operation response. This may not include all response elements, such as those that are too large, privacy-sensitive, or duplicated elsewhere in the log record. It should never include user-generated data, such as file contents. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the &#x60;@type&#x60; property. Defaults to: null. serviceData (%{optional(String.t) &#x3D;&gt; String.t}): Deprecated, use &#x60;metadata&#x60; field instead. Other service-specific data about the request, response, and other activities. Defaults to: null. serviceName (String.t): The name of the API service performing the operation. For example, &#x60;&quot;datastore.googleapis.com&quot;&#x60;. Defaults to: null. status (Status): The status of the overall operation. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AuditLog.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuditLog.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AuditLog.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Auth.html","title":"GoogleApi.ServiceControl.V1.Model.Auth","type":"module","doc":"This message defines request authentication attributes. Terminology is based on the JSON Web Token (JWT) standard, but the terms also correlate to concepts in other standards. Attributes accessLevels ([String.t]): A list of access level resource names that allow resources to be accessed by authenticated requester. It is part of Secure GCP processing for the incoming request. An access level string has the format: &quot;//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}&quot; Example: &quot;//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL&quot; Defaults to: null. audiences ([String.t]): The intended audience(s) for this authentication information. Reflects the audience (&#x60;aud&#x60;) claim within a JWT. The audience value(s) depends on the &#x60;issuer&#x60;, but typically include one or more of the following pieces of information: The services intended to receive the credential such as [&quot;pubsub.googleapis.com&quot;, &quot;storage.googleapis.com&quot;] A set of service-based scopes. For example, [&quot;https://www.googleapis.com/auth/cloud-platform&quot;] * The client id of an app, such as the Firebase project id for JWTs from Firebase Auth. Consult the documentation for the credential issuer to determine the information provided. Defaults to: null. claims (%{optional(String.t) &#x3D;&gt; String.t}): Structured claims presented with the credential. JWTs include &#x60;{key: value}&#x60; pairs for standard and private claims. The following is a subset of the standard required and optional claims that would typically be presented for a Google-based JWT: {&#39;iss&#39;: &#39;accounts.google.com&#39;, &#39;sub&#39;: &#39;113289723416554971153&#39;, &#39;aud&#39;: [&#39;123456789012&#39;, &#39;pubsub.googleapis.com&#39;], &#39;azp&#39;: &#39;123456789012.apps.googleusercontent.com&#39;, &#39;email&#39;: &#39;jsmith@example.com&#39;, &#39;iat&#39;: 1353601026, &#39;exp&#39;: 1353604926} SAML assertions are similarly specified, but with an identity provider dependent structure. Defaults to: null. presenter (String.t): The authorized presenter of the credential. Reflects the optional Authorized Presenter (&#x60;azp&#x60;) claim within a JWT or the OAuth client id. For example, a Google Cloud Platform client id looks as follows: &quot;123456789012.apps.googleusercontent.com&quot;. Defaults to: null. principal (String.t): The authenticated principal. Reflects the issuer (&#x60;iss&#x60;) and subject (&#x60;sub&#x60;) claims within a JWT. The issuer and subject should be &#x60;/&#x60; delimited, with &#x60;/&#x60; percent-encoded within the subject fragment. For Google accounts, the principal format is: &quot;https://accounts.google.com/{id}&quot; Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.Auth.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Auth.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Auth.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Auth.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo","type":"module","doc":"Authentication information for the operation. Attributes authoritySelector (String.t): The authority selector specified by the requestor, if any. It is not guaranteed that the principal was allowed to use this authority. Defaults to: null. principalEmail (String.t): The email address of the authenticated user (or service account on behalf of third party principal) making the request. For privacy reasons, the principal email address is redacted for all read-only operations that fail with a &quot;permission denied&quot; error. Defaults to: null. serviceAccountDelegationInfo ([ServiceAccountDelegationInfo]): Identity delegation history of an authenticated service account that makes the request. It contains information on the real authorities that try to access GCP resources by delegating on a service account. When multiple authorities present, they are guaranteed to be sorted based on the original ordering of the identity delegation events. Defaults to: null. serviceAccountKeyName (String.t): The name of the service account key used to create or exchange credentials for authenticating the service account making the request. This is a scheme-less URI full resource name. For example: &quot;//iam.googleapis.com/projects/{PROJECT_ID}/serviceAccounts/{ACCOUNT}/keys/{key}&quot; Defaults to: null. thirdPartyPrincipal (%{optional(String.t) &#x3D;&gt; String.t}): The third party identification (if any) of the authenticated user making the request. When the JSON object represented here has a proto equivalent, the proto name will be indicated in the &#x60;@type&#x60; property. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AuthenticationInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo","type":"module","doc":"Authorization information for the operation. Attributes granted (boolean()): Whether or not authorization for &#x60;resource&#x60; and &#x60;permission&#x60; was granted. Defaults to: null. permission (String.t): The required IAM permission. Defaults to: null. resource (String.t): The resource being accessed, as a REST-style string. For example: bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID Defaults to: null. resourceAttributes (Resource): Resource attributes used in IAM condition evaluation. This field contains resource attributes like resource type and resource name. To get the whole view of the attributes used in IAM condition evaluation, the user must also look into &#x60;AuditLog.request_metadata.request_attributes&#x60;. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.AuthorizationInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html","title":"GoogleApi.ServiceControl.V1.Model.CheckError","type":"module","doc":"Defines the errors to be returned in google.api.servicecontrol.v1.CheckResponse.check_errors. Attributes code (String.t): The error code. Defaults to: null. Enum - one of [ERROR_CODE_UNSPECIFIED, NOT_FOUND, PERMISSION_DENIED, RESOURCE_EXHAUSTED, BUDGET_EXCEEDED, DENIAL_OF_SERVICE_DETECTED, LOAD_SHEDDING, ABUSER_DETECTED, SERVICE_NOT_ACTIVATED, VISIBILITY_DENIED, BILLING_DISABLED, PROJECT_DELETED, PROJECT_INVALID, CONSUMER_INVALID, IP_ADDRESS_BLOCKED, REFERER_BLOCKED, CLIENT_APP_BLOCKED, API_TARGET_BLOCKED, API_KEY_INVALID, API_KEY_EXPIRED, API_KEY_NOT_FOUND, SPATULA_HEADER_INVALID, LOAS_ROLE_INVALID, NO_LOAS_PROJECT, LOAS_PROJECT_DISABLED, SECURITY_POLICY_VIOLATED, INVALID_CREDENTIAL, LOCATION_POLICY_VIOLATED, NAMESPACE_LOOKUP_UNAVAILABLE, SERVICE_STATUS_UNAVAILABLE, BILLING_STATUS_UNAVAILABLE, QUOTA_CHECK_UNAVAILABLE, LOAS_PROJECT_LOOKUP_UNAVAILABLE, CLOUD_RESOURCE_MANAGER_BACKEND_UNAVAILABLE, SECURITY_POLICY_BACKEND_UNAVAILABLE, LOCATION_POLICY_BACKEND_UNAVAILABLE] detail (String.t): Free-form text providing details on the error cause of the error. Defaults to: null. status (Status): Contains public information about the check error. If available, &#x60;status.code&#x60; will be non zero and client can propagate it out as public error. Defaults to: null. subject (String.t): Subject to whom this error applies. See the specific code enum for more details on this field. For example: - “project:&lt;project-id or project-number&gt;” - “folder:&lt;folder-id&gt;” - “organization:&lt;organization-id&gt;” Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.CheckError.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckError.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.CheckError.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo","type":"module","doc":"Contains additional information about the check operation. Attributes consumerInfo (ConsumerInfo): Consumer info of this check. Defaults to: null. unusedArguments ([String.t]): A list of fields and label keys that are ignored by the server. The client doesn&#39;t need to send them for following requests to improve performance and allow better aggregation. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.CheckInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest","type":"module","doc":"Request message for the Check method. Attributes operation (Operation): The operation to be checked. Defaults to: null. requestProjectSettings (boolean()): Requests the project settings to be returned as part of the check response. Defaults to: null. serviceConfigId (String.t): Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to: null. skipActivationCheck (boolean()): Indicates if service activation check should be skipped for this request. Default behavior is to perform the check and apply relevant quota. WARNING: Setting this flag to &quot;true&quot; will disable quota enforcement. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.CheckRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse","type":"module","doc":"Response message for the Check method. Attributes checkErrors ([CheckError]): Indicate the decision of the check. If no check errors are present, the service should process the operation. Otherwise the service should use the list of errors to determine the appropriate action. Defaults to: null. checkInfo (CheckInfo): Feedback data returned from the server during processing a Check request. Defaults to: null. operationId (String.t): The same operation_id value used in the CheckRequest. Used for logging and diagnostics purposes. Defaults to: null. quotaInfo (QuotaInfo): Quota information for the check request associated with this response. Defaults to: null. serviceConfigId (String.t): The actual config id used to process the request. Defaults to: null. serviceRolloutId (String.t): Unimplemented. The current service rollout id used to process the request. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.CheckResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.CheckResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo","type":"module","doc":"&#x60;ConsumerInfo&#x60; provides information about the consumer. Attributes consumerNumber (String.t): The consumer identity number, can be Google cloud project number, folder number or organization number e.g. 1234567890. A value of 0 indicates no consumer number is found. Defaults to: null. projectNumber (String.t): The Google cloud project number, e.g. 1234567890. A value of 0 indicates no project number is found. NOTE: This field is deprecated after Chemist support flexible consumer id. New code should not depend on this field anymore. Defaults to: null. type (String.t): The type of the consumer which should have been defined in Google Resource Manager. Defaults to: null. Enum - one of [CONSUMER_TYPE_UNSPECIFIED, PROJECT, FOLDER, ORGANIZATION, SERVICE_SPECIFIC]"},{"ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ConsumerInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html","title":"GoogleApi.ServiceControl.V1.Model.Distribution","type":"module","doc":"Distribution represents a frequency distribution of double-valued sample points. It contains the size of the population of sample points plus additional optional information: - the arithmetic mean of the samples - the minimum and maximum of the samples - the sum-squared-deviation of the samples, used to compute variance - a histogram of the values of the sample points Attributes bucketCounts ([String.t]): The number of samples in each histogram bucket. &#x60;bucket_counts&#x60; are optional. If present, they must sum to the &#x60;count&#x60; value. The buckets are defined below in &#x60;bucket_option&#x60;. There are N buckets. &#x60;bucket_counts[0]&#x60; is the number of samples in the underflow bucket. &#x60;bucket_counts[1]&#x60; to &#x60;bucket_counts[N-1]&#x60; are the numbers of samples in each of the finite buckets. And &#x60;bucket_counts[N] is the number of samples in the overflow bucket. See the comments of &#x60;bucket_option&#x60; below for more details. Any suffix of trailing zeros may be omitted. Defaults to: null. count (String.t): The total number of samples in the distribution. Must be &gt;&#x3D; 0. Defaults to: null. explicitBuckets (ExplicitBuckets): Buckets with arbitrary user-provided width. Defaults to: null. exponentialBuckets (ExponentialBuckets): Buckets with exponentially growing width. Defaults to: null. linearBuckets (LinearBuckets): Buckets with constant width. Defaults to: null. maximum (float()): The maximum of the population of values. Ignored if &#x60;count&#x60; is zero. Defaults to: null. mean (float()): The arithmetic mean of the samples in the distribution. If &#x60;count&#x60; is zero then this field must be zero. Defaults to: null. minimum (float()): The minimum of the population of values. Ignored if &#x60;count&#x60; is zero. Defaults to: null. sumOfSquaredDeviation (float()): The sum of squared deviations from the mean: Sumi&#x3D;1..count where each x_i is a sample values. If &#x60;count&#x60; is zero then this field must be zero, otherwise validation of the request fails. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Distribution.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Distribution.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Distribution.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.EndReconciliationRequest.html","title":"GoogleApi.ServiceControl.V1.Model.EndReconciliationRequest","type":"module","doc":"Request message for QuotaController.EndReconciliation. Attributes reconciliationOperation (QuotaOperation): Operation that describes the quota reconciliation. Defaults to: null. serviceConfigId (String.t): Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.EndReconciliationRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.EndReconciliationRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.EndReconciliationRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.EndReconciliationRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.EndReconciliationResponse.html","title":"GoogleApi.ServiceControl.V1.Model.EndReconciliationResponse","type":"module","doc":"Response message for QuotaController.EndReconciliation. Attributes operationId (String.t): The same operation_id value used in the EndReconciliationRequest. Used for logging and diagnostics purposes. Defaults to: null. quotaMetrics ([MetricValueSet]): Metric values as tracked by One Platform before the adjustment was made. The following metrics will be included: 1. Per quota metric total usage will be specified using the following gauge metric: &quot;serviceruntime.googleapis.com/allocation/consumer/quota_used_count&quot; 2. Value for each quota limit associated with the metrics will be specified using the following gauge metric: &quot;serviceruntime.googleapis.com/quota/limit&quot; 3. Delta value of the usage after the reconciliation for limits associated with the metrics will be specified using the following metric: &quot;serviceruntime.googleapis.com/allocation/reconciliation_delta&quot; The delta value is defined as: new_usage_from_client - existing_value_in_spanner. This metric is not defined in serviceruntime.yaml or in Cloud Monarch. This metric is meant for callers&#39; use only. Since this metric is not defined in the monitoring backend, reporting on this metric will result in an error. Defaults to: null. reconciliationErrors ([QuotaError]): Indicates the decision of the reconciliation end. Defaults to: null. serviceConfigId (String.t): ID of the actual config used to process the request. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.EndReconciliationResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.EndReconciliationResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.EndReconciliationResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.EndReconciliationResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets","type":"module","doc":"Describing buckets with arbitrary user-provided width. Attributes bounds ([float()]): &#39;bound&#39; is a list of strictly increasing boundaries between buckets. Note that a list of length N-1 defines N buckets because of fenceposting. See comments on &#x60;bucket_options&#x60; for details. The i&#39;th finite bucket covers the interval [bound[i-1], bound[i]) where i ranges from 1 to bound_size() - 1. Note that there are no finite buckets at all if &#39;bound&#39; only contains a single element; in that special case the single bound defines the boundary between the underflow and overflow buckets. bucket number lower bound upper bound i &#x3D;&#x3D; 0 (underflow) -inf bound[i] 0 &lt; i &lt; bound_size() bound[i-1] bound[i] i &#x3D;&#x3D; bound_size() (overflow) bound[i-1] +inf Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ExplicitBuckets.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets","type":"module","doc":"Describing buckets with exponentially growing width. Attributes growthFactor (float()): The i&#39;th exponential bucket covers the interval [scale growth_factor^(i-1), scale growth_factor^i) where i ranges from 1 to num_finite_buckets inclusive. Must be larger than 1.0. Defaults to: null. numFiniteBuckets (integer()): The number of finite buckets. With the underflow and overflow buckets, the total number of buckets is &#x60;num_finite_buckets&#x60; + 2. See comments on &#x60;bucket_options&#x60; for details. Defaults to: null. scale (float()): The i&#39;th exponential bucket covers the interval [scale growth_factor^(i-1), scale growth_factor^i) where i ranges from 1 to num_finite_buckets inclusive. Must be &gt; 0. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ExponentialBuckets.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal","type":"module","doc":"First party identity principal. Attributes principalEmail (String.t): The email address of a Google account. . Defaults to: null. serviceMetadata (%{optional(String.t) &#x3D;&gt; String.t}): Metadata about the service that uses the service account. . Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.FirstPartyPrincipal.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest","type":"module","doc":"A common proto for logging HTTP requests. Only contains semantics defined by the HTTP specification. Product-specific logging information MUST be defined in a separate message. Attributes cacheFillBytes (String.t): The number of HTTP response bytes inserted into cache. Set only when a cache fill was attempted. Defaults to: null. cacheHit (boolean()): Whether or not an entity was served from cache (with or without validation). Defaults to: null. cacheLookup (boolean()): Whether or not a cache lookup was attempted. Defaults to: null. cacheValidatedWithOriginServer (boolean()): Whether or not the response was validated with the origin server before being served from cache. This field is only meaningful if &#x60;cache_hit&#x60; is True. Defaults to: null. latency (String.t): The request processing latency on the server, from the time the request was received until the response was sent. Defaults to: null. protocol (String.t): Protocol used for the request. Examples: &quot;HTTP/1.1&quot;, &quot;HTTP/2&quot;, &quot;websocket&quot; Defaults to: null. referer (String.t): The referer URL of the request, as defined in HTTP/1.1 Header Field Definitions. Defaults to: null. remoteIp (String.t): The IP address (IPv4 or IPv6) of the client that issued the HTTP request. Examples: &#x60;&quot;192.168.1.1&quot;&#x60;, &#x60;&quot;FE80::0202:B3FF:FE1E:8329&quot;&#x60;. Defaults to: null. requestMethod (String.t): The request method. Examples: &#x60;&quot;GET&quot;&#x60;, &#x60;&quot;HEAD&quot;&#x60;, &#x60;&quot;PUT&quot;&#x60;, &#x60;&quot;POST&quot;&#x60;. Defaults to: null. requestSize (String.t): The size of the HTTP request message in bytes, including the request headers and the request body. Defaults to: null. requestUrl (String.t): The scheme (http, https), the host name, the path, and the query portion of the URL that was requested. Example: &#x60;&quot;http://example.com/some/info?color&#x3D;red&quot;&#x60;. Defaults to: null. responseSize (String.t): The size of the HTTP response message sent back to the client, in bytes, including the response headers and the response body. Defaults to: null. serverIp (String.t): The IP address (IPv4 or IPv6) of the origin server that the request was sent to. Defaults to: null. status (integer()): The response code indicating the status of the response. Examples: 200, 404. Defaults to: null. userAgent (String.t): The user agent sent by the client. Example: &#x60;&quot;Mozilla/4.0 (compatible; MSIE 6.0; Windows 98; Q312461; .NET CLR 1.0.3705)&quot;&#x60;. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.HttpRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.HttpRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets","type":"module","doc":"Describing buckets with constant width. Attributes numFiniteBuckets (integer()): The number of finite buckets. With the underflow and overflow buckets, the total number of buckets is &#x60;num_finite_buckets&#x60; + 2. See comments on &#x60;bucket_options&#x60; for details. Defaults to: null. offset (float()): The i&#39;th linear bucket covers the interval [offset + (i-1) width, offset + i width) where i ranges from 1 to num_finite_buckets, inclusive. Defaults to: null. width (float()): The i&#39;th linear bucket covers the interval [offset + (i-1) width, offset + i width) where i ranges from 1 to num_finite_buckets, inclusive. Must be strictly positive. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.LinearBuckets.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html","title":"GoogleApi.ServiceControl.V1.Model.LogEntry","type":"module","doc":"An individual log entry. Attributes httpRequest (HttpRequest): Optional. Information about the HTTP request associated with this log entry, if applicable. Defaults to: null. insertId (String.t): A unique ID for the log entry used for deduplication. If omitted, the implementation will generate one based on operation_id. Defaults to: null. labels (%{optional(String.t) &#x3D;&gt; String.t}): A set of user-defined (key, value) data that provides additional information about the log entry. Defaults to: null. name (String.t): Required. The log to which this log entry belongs. Examples: &#x60;&quot;syslog&quot;&#x60;, &#x60;&quot;book_log&quot;&#x60;. Defaults to: null. operation (LogEntryOperation): Optional. Information about an operation associated with the log entry, if applicable. Defaults to: null. protoPayload (%{optional(String.t) &#x3D;&gt; String.t}): The log entry payload, represented as a protocol buffer that is expressed as a JSON object. The only accepted type currently is AuditLog. Defaults to: null. severity (String.t): The severity of the log entry. The default value is &#x60;LogSeverity.DEFAULT&#x60;. Defaults to: null. Enum - one of [DEFAULT, DEBUG, INFO, NOTICE, WARNING, ERROR, CRITICAL, ALERT, EMERGENCY] structPayload (%{optional(String.t) &#x3D;&gt; String.t}): The log entry payload, represented as a structure that is expressed as a JSON object. Defaults to: null. textPayload (String.t): The log entry payload, represented as a Unicode string (UTF-8). Defaults to: null. timestamp (DateTime.t): The time the event described by the log entry occurred. If omitted, defaults to operation start time. Defaults to: null. trace (String.t): Optional. Resource name of the trace associated with the log entry, if any. If this field contains a relative resource name, you can assume the name is relative to &#x60;//tracing.googleapis.com&#x60;. Example: &#x60;projects/my-projectid/traces/06796866738c859f2f19b7cfb3214824&#x60; Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.LogEntry.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntry.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.LogEntry.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation","type":"module","doc":"Additional information about a potentially long-running operation with which a log entry is associated. Attributes first (boolean()): Optional. Set this to True if this is the first log entry in the operation. Defaults to: null. id (String.t): Optional. An arbitrary operation identifier. Log entries with the same identifier are assumed to be part of the same operation. Defaults to: null. last (boolean()): Optional. Set this to True if this is the last log entry in the operation. Defaults to: null. producer (String.t): Optional. An arbitrary producer identifier. The combination of &#x60;id&#x60; and &#x60;producer&#x60; must be globally unique. Examples for &#x60;producer&#x60;: &#x60;&quot;MyDivision.MyBigCompany.com&quot;&#x60;, &#x60;&quot;github.com/MyProject/MyApplication&quot;&#x60;. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.LogEntryOperation.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html","title":"GoogleApi.ServiceControl.V1.Model.MetricValue","type":"module","doc":"Represents a single metric value. Attributes boolValue (boolean()): A boolean value. Defaults to: null. distributionValue (Distribution): A distribution value. Defaults to: null. doubleValue (float()): A double precision floating point value. Defaults to: null. endTime (DateTime.t): The end of the time period over which this metric value&#39;s measurement applies. Defaults to: null. int64Value (String.t): A signed 64-bit integer value. Defaults to: null. labels (%{optional(String.t) &#x3D;&gt; String.t}): The labels describing the metric value. See comments on google.api.servicecontrol.v1.Operation.labels for the overriding relationship. Defaults to: null. moneyValue (Money): A money value. Defaults to: null. startTime (DateTime.t): The start of the time period over which this metric value&#39;s measurement applies. The time period has different semantics for different metric types (cumulative, delta, and gauge). See the metric definition documentation in the service configuration for details. Defaults to: null. stringValue (String.t): A text string value. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.MetricValue.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValue.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.MetricValue.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet","type":"module","doc":"Represents a set of metric values in the same metric. Each metric value in the set should have a unique combination of start time, end time, and label values. Attributes metricName (String.t): The metric name defined in the service configuration. Defaults to: null. metricValues ([MetricValue]): The values in this metric. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.MetricValueSet.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Money.html","title":"GoogleApi.ServiceControl.V1.Model.Money","type":"module","doc":"Represents an amount of money with its currency type. Attributes currencyCode (String.t): The 3-letter currency code defined in ISO 4217. Defaults to: null. nanos (integer()): Number of nano (10^-9) units of the amount. The value must be between -999,999,999 and +999,999,999 inclusive. If &#x60;units&#x60; is positive, &#x60;nanos&#x60; must be positive or zero. If &#x60;units&#x60; is zero, &#x60;nanos&#x60; can be positive, zero, or negative. If &#x60;units&#x60; is negative, &#x60;nanos&#x60; must be negative or zero. For example $-1.75 is represented as &#x60;units&#x60;&#x3D;-1 and &#x60;nanos&#x60;&#x3D;-750,000,000. Defaults to: null. units (String.t): The whole units of the amount. For example if &#x60;currencyCode&#x60; is &#x60;&quot;USD&quot;&#x60;, then 1 unit is one US dollar. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.Money.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Money.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Money.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Money.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Operation.html","title":"GoogleApi.ServiceControl.V1.Model.Operation","type":"module","doc":"Represents information regarding an operation. Attributes consumerId (String.t): Identity of the consumer who is using the service. This field should be filled in for the operations initiated by a consumer, but not for service-initiated operations that are not related to a specific consumer. - This can be in one of the following formats: - project:PROJECTID, - project&#x60;&#x60;number:PROJECTNUMBER, - projects/PROJECT_ID or PROJECT_NUMBER, - folders/FOLDER_NUMBER, - organizations/ORGANIZATION_NUMBER, - api&#x60;&#x60;key:API_KEY. Defaults to: null. endTime (DateTime.t): End time of the operation. Required when the operation is used in ServiceController.Report, but optional when the operation is used in ServiceController.Check. Defaults to: null. importance (String.t): DO NOT USE. This is an experimental field. Defaults to: null. Enum - one of [LOW, HIGH, DEBUG] labels (%{optional(String.t) &#x3D;&gt; String.t}): Labels describing the operation. Only the following labels are allowed: - Labels describing monitored resources as defined in the service configuration. - Default labels of metric values. When specified, labels defined in the metric value override these default. - The following labels defined by Google Cloud Platform: - &#x60;cloud.googleapis.com/location&#x60; describing the location where the operation happened, - &#x60;servicecontrol.googleapis.com/user_agent&#x60; describing the user agent of the API request, - &#x60;servicecontrol.googleapis.com/service_agent&#x60; describing the service used to handle the API request (e.g. ESP), - &#x60;servicecontrol.googleapis.com/platform&#x60; describing the platform where the API is served, such as App Engine, Compute Engine, or Kubernetes Engine. Defaults to: null. logEntries ([LogEntry]): Represents information to be logged. Defaults to: null. metricValueSets ([MetricValueSet]): Represents information about this operation. Each MetricValueSet corresponds to a metric defined in the service configuration. The data type used in the MetricValueSet must agree with the data type specified in the metric definition. Within a single operation, it is not allowed to have more than one MetricValue instances that have the same metric names and identical label value combinations. If a request has such duplicated MetricValue instances, the entire request is rejected with an invalid argument error. Defaults to: null. operationId (String.t): Identity of the operation. This must be unique within the scope of the service that generated the operation. If the service calls Check() and Report() on the same operation, the two calls should carry the same id. UUID version 4 is recommended, though not required. In scenarios where an operation is computed from existing information and an idempotent id is desirable for deduplication purpose, UUID version 5 is recommended. See RFC 4122 for details. Defaults to: null. operationName (String.t): Fully qualified name of the operation. Reserved for future use. Defaults to: null. quotaProperties (QuotaProperties): Represents the properties needed for quota check. Applicable only if this operation is for a quota check request. If this is not specified, no quota check will be performed. Defaults to: null. resourceContainer (String.t): DO NOT USE. This field is deprecated, use &quot;resources&quot; field instead. The resource name of the parent of a resource in the resource hierarchy. This can be in one of the following formats: - “projects/&lt;project-id or project-number&gt;” - “folders/&lt;folder-id&gt;” - “organizations/&lt;organization-id&gt;” Defaults to: null. resources ([ResourceInfo]): The resources that are involved in the operation. The maximum supported number of entries in this field is 100. Defaults to: null. startTime (DateTime.t): Required. Start time of the operation. Defaults to: null. userLabels (%{optional(String.t) &#x3D;&gt; String.t}): User defined labels for the resource that this operation is associated with. Only a combination of 1000 user labels per consumer project are allowed. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.Operation.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Operation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Operation.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Operation.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Peer.html","title":"GoogleApi.ServiceControl.V1.Model.Peer","type":"module","doc":"This message defines attributes for a node that handles a network request. The node can be either a service or an application that sends, forwards, or receives the request. Service peers should fill in the &#x60;service&#x60;, &#x60;principal&#x60;, and &#x60;labels&#x60; as appropriate. Attributes ip (String.t): The IP address of the peer. Defaults to: null. labels (%{optional(String.t) &#x3D;&gt; String.t}): The labels associated with the peer. Defaults to: null. port (String.t): The network port of the peer. Defaults to: null. principal (String.t): The identity of this peer. Similar to &#x60;Request.auth.principal&#x60;, but relative to the peer instead of the request. For example, the idenity associated with a load balancer that forwared the request. Defaults to: null. regionCode (String.t): The CLDR country/region code associated with the above IP address. If the IP address is private, the &#x60;region_code&#x60; should reflect the physical location where this peer is running. Defaults to: null. service (String.t): The canonical service name of the peer. NOTE: different systems may have different service naming schemes. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.Peer.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Peer.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Peer.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Peer.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html","title":"GoogleApi.ServiceControl.V1.Model.QuotaError","type":"module","doc":"Represents error information for QuotaOperation. Attributes code (String.t): Error code. Defaults to: null. Enum - one of [UNSPECIFIED, RESOURCE_EXHAUSTED, OUT_OF_RANGE, BILLING_NOT_ACTIVE, PROJECT_DELETED, API_KEY_INVALID, API_KEY_EXPIRED, SPATULA_HEADER_INVALID, LOAS_ROLE_INVALID, NO_LOAS_PROJECT, PROJECT_STATUS_UNAVAILABLE, SERVICE_STATUS_UNAVAILABLE, BILLING_STATUS_UNAVAILABLE, QUOTA_SYSTEM_UNAVAILABLE] description (String.t): Free-form text that provides details on the cause of the error. Defaults to: null. subject (String.t): Subject to whom this error applies. See the specific enum for more details on this field. For example, &quot;clientip:&lt;ip address of client&gt;&quot; or &quot;project:&lt;Google developer project id&gt;&quot;. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.QuotaError.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaError.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.QuotaError.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo","type":"module","doc":"Contains the quota information for a quota check response. Attributes limitExceeded ([String.t]): Quota Metrics that have exceeded quota limits. For QuotaGroup-based quota, this is QuotaGroup.name For QuotaLimit-based quota, this is QuotaLimit.name See: google.api.Quota Deprecated: Use quota_metrics to get per quota group limit exceeded status. Defaults to: null. quotaConsumed (%{optional(String.t) &#x3D;&gt; integer()}): Map of quota group name to the actual number of tokens consumed. If the quota check was not successful, then this will not be populated due to no quota consumption. We are not merging this field with &#39;quota_metrics&#39; field because of the complexity of scaling in Chemist client code base. For simplicity, we will keep this field for Castor (that scales quota usage) and &#39;quota_metrics&#39; for SuperQuota (that doesn&#39;t scale quota usage). Defaults to: null. quotaMetrics ([MetricValueSet]): Quota metrics to indicate the usage. Depending on the check request, one or more of the following metrics will be included: 1. For rate quota, per quota group or per quota metric incremental usage will be specified using the following delta metric: &quot;serviceruntime.googleapis.com/api/consumer/quota_used_count&quot; 2. For allocation quota, per quota metric total usage will be specified using the following gauge metric: &quot;serviceruntime.googleapis.com/allocation/consumer/quota_used_count&quot; 3. For both rate quota and allocation quota, the quota limit reached condition will be specified using the following boolean metric: &quot;serviceruntime.googleapis.com/quota/exceeded&quot; Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.QuotaInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation","type":"module","doc":"Represents information regarding a quota operation. Attributes consumerId (String.t): Identity of the consumer for whom this quota operation is being performed. This can be in one of the following formats: project:&lt;project_id&gt;, project_number:&lt;project_number&gt;, api_key:&lt;api_key&gt;. Defaults to: null. labels (%{optional(String.t) &#x3D;&gt; String.t}): Labels describing the operation. Defaults to: null. methodName (String.t): Fully qualified name of the API method for which this quota operation is requested. This name is used for matching quota rules or metric rules and billing status rules defined in service configuration. This field should not be set if any of the following is true: (1) the quota operation is performed on non-API resources. (2) quota_metrics is set because the caller is doing quota override. Example of an RPC method name: google.example.library.v1.LibraryService.CreateShelf Defaults to: null. operationId (String.t): Identity of the operation. This is expected to be unique within the scope of the service that generated the operation, and guarantees idempotency in case of retries. UUID version 4 is recommended, though not required. In scenarios where an operation is computed from existing information and an idempotent id is desirable for deduplication purpose, UUID version 5 is recommended. See RFC 4122 for details. Defaults to: null. quotaMetrics ([MetricValueSet]): Represents information about this operation. Each MetricValueSet corresponds to a metric defined in the service configuration. The data type used in the MetricValueSet must agree with the data type specified in the metric definition. Within a single operation, it is not allowed to have more than one MetricValue instances that have the same metric names and identical label value combinations. If a request has such duplicated MetricValue instances, the entire request is rejected with an invalid argument error. This field is mutually exclusive with method_name. Defaults to: null. quotaMode (String.t): Quota mode for this operation. Defaults to: null. Enum - one of [UNSPECIFIED, NORMAL, BEST_EFFORT, CHECK_ONLY]"},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.QuotaOperation.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties","type":"module","doc":"Represents the properties needed for quota operations. Attributes quotaMode (String.t): Quota mode for this operation. Defaults to: null. Enum - one of [ACQUIRE, ACQUIRE_BEST_EFFORT, CHECK, RELEASE]"},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.QuotaProperties.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaRequest.html","title":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaRequest","type":"module","doc":"Request message for the ReleaseQuota method. Attributes releaseOperation (QuotaOperation): Operation that describes the quota release. Defaults to: null. serviceConfigId (String.t): Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaResponse.html","title":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaResponse","type":"module","doc":"Response message for the ReleaseQuota method. Attributes operationId (String.t): The same operation_id value used in the ReleaseQuotaRequest. Used for logging and diagnostics purposes. Defaults to: null. quotaMetrics ([MetricValueSet]): Quota metrics to indicate the result of release. Depending on the request, one or more of the following metrics will be included: 1. For rate quota, per quota group or per quota metric released amount will be specified using the following delta metric: &quot;serviceruntime.googleapis.com/api/consumer/quota_refund_count&quot; 2. For allocation quota, per quota metric total usage will be specified using the following gauge metric: &quot;serviceruntime.googleapis.com/allocation/consumer/quota_used_count&quot; 3. For allocation quota, value for each quota limit associated with the metrics will be specified using the following gauge metric: &quot;serviceruntime.googleapis.com/quota/limit&quot; Defaults to: null. releaseErrors ([QuotaError]): Indicates the decision of the release. Defaults to: null. serviceConfigId (String.t): ID of the actual config used to process the request. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReleaseQuotaResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html","title":"GoogleApi.ServiceControl.V1.Model.ReportError","type":"module","doc":"Represents the processing error of one Operation in the request. Attributes operationId (String.t): The Operation.operation_id value from the request. Defaults to: null. status (Status): Details of the error when processing the Operation. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReportError.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportError.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReportError.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportInfo.html","title":"GoogleApi.ServiceControl.V1.Model.ReportInfo","type":"module","doc":"Contains additional info about the report operation. Attributes operationId (String.t): The Operation.operation_id value from the request. Defaults to: null. quotaInfo (QuotaInfo): Quota usage info when processing the &#x60;Operation&#x60;. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReportInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReportInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest","type":"module","doc":"Request message for the Report method. Attributes operations ([Operation]): Operations to be reported. Typically the service should report one operation per request. Putting multiple operations into a single request is allowed, but should be used only when multiple operations are natually available at the time of the report. If multiple operations are in a single request, the total request size should be no larger than 1MB. See ReportResponse.report_errors for partial failure behavior. Defaults to: null. serviceConfigId (String.t): Specifies which version of service config should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReportRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse","type":"module","doc":"Response message for the Report method. Attributes reportErrors ([ReportError]): Partial failures, one for each &#x60;Operation&#x60; in the request that failed processing. There are three possible combinations of the RPC status: 1. The combination of a successful RPC status and an empty &#x60;report_errors&#x60; list indicates a complete success where all &#x60;Operations&#x60; in the request are processed successfully. 2. The combination of a successful RPC status and a non-empty &#x60;report_errors&#x60; list indicates a partial success where some &#x60;Operations&#x60; in the request succeeded. Each &#x60;Operation&#x60; that failed processing has a corresponding item in this list. 3. A failed RPC status indicates a general non-deterministic failure. When this happens, it&#39;s impossible to know which of the &#39;Operations&#39; in the request succeeded or failed. Defaults to: null. reportInfos ([ReportInfo]): Quota usage for each quota release &#x60;Operation&#x60; request. Fully or partially failed quota release request may or may not be present in &#x60;report_quota_info&#x60;. For example, a failed quota release request will have the current quota usage info when precise quota library returns the info. A deadline exceeded quota request will not have quota usage info. If there is no quota release request, report_quota_info will be empty. Defaults to: null. serviceConfigId (String.t): The actual config id used to process the request. Defaults to: null. serviceRolloutId (String.t): Unimplemented. The current service rollout id used to process the request. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ReportResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ReportResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Request.html","title":"GoogleApi.ServiceControl.V1.Model.Request","type":"module","doc":"This message defines attributes for an HTTP request. If the actual request is not an HTTP request, the runtime system should try to map the actual request to an equivalent HTTP request. Attributes host (String.t): The HTTP request &#x60;Host&#x60; header value. Defaults to: null. auth (Auth): The request authentication. May be absent for unauthenticated requests. Derived from the HTTP request &#x60;Authorization&#x60; header or equivalent. Defaults to: null. fragment (String.t): The HTTP URL fragment. No URL decoding is performed. Defaults to: null. headers (%{optional(String.t) &#x3D;&gt; String.t}): The HTTP request headers. If multiple headers share the same key, they must be merged according to the HTTP spec. All header keys must be lowercased, because HTTP header keys are case-insensitive. Defaults to: null. id (String.t): The unique ID for a request, which can be propagated to downstream systems. The ID should have low probability of collision within a single day for a specific service. Defaults to: null. method (String.t): The HTTP request method, such as &#x60;GET&#x60;, &#x60;POST&#x60;. Defaults to: null. path (String.t): The HTTP URL path. Defaults to: null. protocol (String.t): The network protocol used with the request, such as &quot;http/1.1&quot;, &quot;spdy/3&quot;, &quot;h2&quot;, &quot;h2c&quot;, &quot;webrtc&quot;, &quot;tcp&quot;, &quot;udp&quot;, &quot;quic&quot;. See https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids for details. Defaults to: null. query (String.t): The HTTP URL query in the format of &#x60;name1&#x3D;value&#x60;&amp;name2&#x3D;value2&#x60;, as it appears in the first line of the HTTP request. No decoding is performed. Defaults to: null. reason (String.t): A special parameter for request reason. It is used by security systems to associate auditing information with a request. Defaults to: null. scheme (String.t): The HTTP URL scheme, such as &#x60;http&#x60; and &#x60;https&#x60;. Defaults to: null. size (String.t): The HTTP request size in bytes. If unknown, it must be -1. Defaults to: null. time (DateTime.t): The timestamp when the &#x60;destination&#x60; service receives the first byte of the request. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.Request.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Request.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Request.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Request.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata","type":"module","doc":"Metadata about the request. Attributes callerIp (String.t): The IP address of the caller. For caller from internet, this will be public IPv4 or IPv6 address. For caller from a Compute Engine VM with external IP address, this will be the VM&#39;s external IP address. For caller from a Compute Engine VM without external IP address, if the VM is in the same organization (or project) as the accessed resource, &#x60;caller_ip&#x60; will be the VM&#39;s internal IPv4 address, otherwise the &#x60;caller_ip&#x60; will be redacted to &quot;gce-internal-ip&quot;. See https://cloud.google.com/compute/docs/vpc/ for more information. Defaults to: null. callerNetwork (String.t): The network of the caller. Set only if the network host project is part of the same GCP organization (or project) as the accessed resource. See https://cloud.google.com/compute/docs/vpc/ for more information. This is a scheme-less URI full resource name. For example: &quot;//compute.googleapis.com/projects/PROJECT_ID/global/networks/NETWORK_ID&quot; Defaults to: null. callerSuppliedUserAgent (String.t): The user agent of the caller. This information is not authenticated and should be treated accordingly. For example: + &#x60;google-api-python-client/1.4.0&#x60;: The request was made by the Google API client for Python. + &#x60;Cloud SDK Command Line Tool apitools-client/1.0 gcloud/0.9.62&#x60;: The request was made by the Google Cloud SDK CLI (gcloud). + &#x60;AppEngine-Google; (+http://code.google.com/appengine; appid: s~my-project&#x60;: The request was made from the &#x60;my-project&#x60; App Engine app. NOLINT Defaults to: null. destinationAttributes (Peer): The destination of a network activity, such as accepting a TCP connection. In a multi hop network activity, the destination represents the receiver of the last hop. Only two fields are used in this message, Peer.port and Peer.ip. These fields are optionally populated by those services utilizing the IAM condition feature. Defaults to: null. requestAttributes (Request): Request attributes used in IAM condition evaluation. This field contains request attributes like request time and access levels associated with the request. To get the whole view of the attributes used in IAM condition evaluation, the user must also look into &#x60;AuditLog.authentication_info.resource_attributes&#x60;. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.RequestMetadata.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Resource.html","title":"GoogleApi.ServiceControl.V1.Model.Resource","type":"module","doc":"This message defines core attributes for a resource. A resource is an addressable (named) entity provided by the destination service. For example, a file stored on a network storage service. Attributes labels (%{optional(String.t) &#x3D;&gt; String.t}): The labels or tags on the resource, such as AWS resource tags and Kubernetes resource labels. Defaults to: null. name (String.t): The stable identifier (name) of a resource on the &#x60;service&#x60;. A resource can be logically identified as &quot;//{resource.service}/{resource.name}&quot;. The differences between a resource name and a URI are: Resource name is a logical identifier, independent of network protocol and API version. For example, &#x60;//pubsub.googleapis.com/projects/123/topics/news-feed&#x60;. URI often includes protocol and version information, so it can be used directly by applications. For example, &#x60;https://pubsub.googleapis.com/v1/projects/123/topics/news-feed&#x60;. See https://cloud.google.com/apis/design/resource_names for details. Defaults to: null. service (String.t): The name of the service that this resource belongs to, such as &#x60;pubsub.googleapis.com&#x60;. The service may be different from the DNS hostname that actually serves the request. Defaults to: null. type (String.t): The type of the resource. The scheme is platform-specific because different platforms define their resources differently. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.Resource.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Resource.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Resource.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Resource.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo","type":"module","doc":"Describes a resource associated with this operation. Attributes resourceContainer (String.t): The identifier of the parent of this resource instance. Must be in one of the following formats: - “projects/&lt;project-id or project-number&gt;” - “folders/&lt;folder-id&gt;” - “organizations/&lt;organization-id&gt;” Defaults to: null. resourceLocation (String.t): The location of the resource. If not empty, the resource will be checked against location policy. The value must be a valid zone, region or multiregion. For example: &quot;europe-west4&quot; or &quot;northamerica-northeast1-a&quot; Defaults to: null. resourceName (String.t): Name of the resource. This is used for auditing purposes. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ResourceInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation","type":"module","doc":"Location information about a resource. Attributes currentLocations ([String.t]): The locations of a resource after the execution of the operation. Requests to create or delete a location based resource must populate the &#39;current_locations&#39; field and not the &#39;original_locations&#39; field. For example: &quot;europe-west1-a&quot; &quot;us-east1&quot; &quot;nam3&quot; Defaults to: null. originalLocations ([String.t]): The locations of a resource prior to the execution of the operation. Requests that mutate the resource&#39;s location must populate both the &#39;original_locations&#39; as well as the &#39;current_locations&#39; fields. For example: &quot;europe-west1-a&quot; &quot;us-east1&quot; &quot;nam3&quot; Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ResourceLocation.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo","type":"module","doc":"Identity delegation history of an authenticated service account. Attributes firstPartyPrincipal (FirstPartyPrincipal): First party (Google) identity as the real authority. Defaults to: null. thirdPartyPrincipal (ThirdPartyPrincipal): Third party identity as the real authority. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ServiceAccountDelegationInfo.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.StartReconciliationRequest.html","title":"GoogleApi.ServiceControl.V1.Model.StartReconciliationRequest","type":"module","doc":"Request message for QuotaController.StartReconciliation. Attributes reconciliationOperation (QuotaOperation): Operation that describes the quota reconciliation. Defaults to: null. serviceConfigId (String.t): Specifies which version of service configuration should be used to process the request. If unspecified or no matching version can be found, the latest one will be used. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.StartReconciliationRequest.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.StartReconciliationRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.StartReconciliationRequest.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.StartReconciliationRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.StartReconciliationResponse.html","title":"GoogleApi.ServiceControl.V1.Model.StartReconciliationResponse","type":"module","doc":"Response message for QuotaController.StartReconciliation. Attributes operationId (String.t): The same operation_id value used in the StartReconciliationRequest. Used for logging and diagnostics purposes. Defaults to: null. quotaMetrics ([MetricValueSet]): Metric values as tracked by One Platform before the start of reconciliation. The following metrics will be included: 1. Per quota metric total usage will be specified using the following gauge metric: &quot;serviceruntime.googleapis.com/allocation/consumer/quota_used_count&quot; 2. Value for each quota limit associated with the metrics will be specified using the following gauge metric: &quot;serviceruntime.googleapis.com/quota/limit&quot; Defaults to: null. reconciliationErrors ([QuotaError]): Indicates the decision of the reconciliation start. Defaults to: null. serviceConfigId (String.t): ID of the actual config used to process the request. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.StartReconciliationResponse.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.StartReconciliationResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.StartReconciliationResponse.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.StartReconciliationResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.Status.html","title":"GoogleApi.ServiceControl.V1.Model.Status","type":"module","doc":"The &#x60;Status&#x60; type defines a logical error model that is suitable for different programming environments, including REST APIs and RPC APIs. It is used by gRPC. The error model is designed to be: - Simple to use and understand for most users - Flexible enough to meet unexpected needs # Overview The &#x60;Status&#x60; message contains three pieces of data: error code, error message, and error details. The error code should be an enum value of google.rpc.Code, but it may accept additional error codes if needed. The error message should be a developer-facing English message that helps developers understand and resolve the error. If a localized user-facing error message is needed, put the localized message in the error details or localize it in the client. The optional error details may contain arbitrary information about the error. There is a predefined set of error detail types in the package &#x60;google.rpc&#x60; that can be used for common error conditions. # Language mapping The &#x60;Status&#x60; message is the logical representation of the error model, but it is not necessarily the actual wire format. When the &#x60;Status&#x60; message is exposed in different client libraries and different wire protocols, it can be mapped differently. For example, it will likely be mapped to some exceptions in Java, but more likely mapped to some error codes in C. # Other uses The error model and the &#x60;Status&#x60; message can be used in a variety of environments, either with or without APIs, to provide a consistent developer experience across different environments. Example uses of this error model include: - Partial errors. If a service needs to return partial errors to the client, it may embed the &#x60;Status&#x60; in the normal response to indicate the partial errors. - Workflow errors. A typical workflow has multiple steps. Each step may have a &#x60;Status&#x60; message for error reporting. - Batch operations. If a client uses batch request and batch response, the &#x60;Status&#x60; message should be used directly inside batch response, one for each error sub-response. - Asynchronous operations. If an API call embeds asynchronous operation results in its response, the status of those operations should be represented directly using the &#x60;Status&#x60; message. - Logging. If some API errors are stored in logs, the message &#x60;Status&#x60; could be used directly after any stripping needed for security/privacy reasons. Attributes code (integer()): The status code, which should be an enum value of google.rpc.Code. Defaults to: null. details ([Object]): A list of messages that carry the error details. There is a common set of message types for APIs to use. Defaults to: null. message (String.t): A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.Status.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.Status.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.Status.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.Status.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal","type":"module","doc":"Third party identity principal. Attributes thirdPartyClaims (%{optional(String.t) &#x3D;&gt; String.t}): Metadata about third party identity. Defaults to: null."},{"ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html#decode/2","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.html#t:t/0","title":"GoogleApi.ServiceControl.V1.Model.ThirdPartyPrincipal.t/0","type":"type","doc":""},{"ref":"GoogleApi.ServiceControl.V1.RequestBuilder.html","title":"GoogleApi.ServiceControl.V1.RequestBuilder","type":"module","doc":"Helper functions for building Tesla requests. This module is no longer used. Please use GoogleApi.Gax.Request instead."}]